=== debian/changelog ===
guitarix (0.10.0-2) unstable; urgency=low

  * Add patch to create rc file on startup, backport from upstream's 0.11.0 for
    squeeze's 0.10.0 line (Closes: #592227)

 -- Roland Stigge <stigge@antcom.de>  Sun, 08 Aug 2010 20:38:28 +0200

guitarix (0.10.0-1) unstable; urgency=low

  * First revision in Debian (Closes: #543923)
  * Source format: 3.0 (quilt)
  * debian/control: Standards-Version: 3.9.1

 -- Roland Stigge <stigge@antcom.de>  Mon, 26 Jul 2010 22:20:04 +0200
