=== debian/control ===
Source: guitarix
Section: sound
Priority: extra
Maintainer: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 7), python, libjack-dev, libsndfile1-dev, libgtk2.0-dev, ladspa-sdk, libzita-convolver-dev, libgtkmm-2.4-dev, libboost1.42-dev
Standards-Version: 3.9.1
Homepage: http://guitarix.sourceforge.net/

Package: guitarix
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: jack-capture, vorbistools, lame
Description: Rock guitar amplifier for Jack
 Guitarix is a rock guitar amplifier for Jack (Jack Audio Connection Kit) with
 one input and two output's. It is designed to get nice trash/metall/rock/guitar
 sounds.  Available are controls for bass, treble, gain, balance, distortion,
 freeverb, crybaby(wah) and echo. For the 'pressure' in the sound you can use
 the feedback and feedforward sliders. guitarix comes with a GTK Interface and
 as Ladspa plugin.
